<script lang="ts"  setup>
import {useRealEstateStore} from "../store/RealEstateStore";
import {computed, ref, watch} from "vue";
import {RealEstate} from "../domain/RealEstate";
import RealEstateListEntry from "../components/RealEstateListEntry.vue";
import {filterGreaterEqThan, filterSmallerEqThan} from "../utils/filters";
import {RealEstateFilters} from "../components/RealEstateFilters";
import {useRouter} from "vue-router";

const store = useRealEstateStore()
const router = useRouter()

const searchQuery = ref('')
const filters = ref<RealEstateFilters>({})
const filtersOpen = ref(false)
const filteredItems = ref<RealEstate[]>([])
const page = ref(1)
function filterSearchQuery(item: RealEstate, search?: string) {
  if (!search) return true
  const lowercaseQuery = search.toLowerCase()
  return item.description.toLowerCase().includes(lowercaseQuery)
    || item.address.toLowerCase().includes(lowercaseQuery)
    || item.locationDescription.toLowerCase().includes(lowercaseQuery)
}

function clickRealEstateDetails(item: RealEstate) {
  router.push({ name: 'RealEstateDetails', params: { id: item.uid }})
}

const pagesCount = computed(() => Math.ceil(filteredItems.value.length / 5))

function filterItems () {
  filteredItems.value = store.entries.filter((item) => {
    return filterSearchQuery(item, searchQuery.value)
      && filterGreaterEqThan(item.price, filters.value.priceFrom)
      && filterSmallerEqThan(item.price, filters.value.priceTo)
      && filterGreaterEqThan(item.sqm, filters.value.sqmFrom)
      && filterSmallerEqThan(item.sqm, filters.value.sqmTo)
      && filterGreaterEqThan(item.rooms, filters.value.roomsFrom)
      && filterSmallerEqThan(item.rooms, filters.value.roomsTo)
      && filterGreaterEqThan(item.bathrooms, filters.value.bathroomsFrom)
      && filterSmallerEqThan(item.bathrooms, filters.value.bathroomsTo)
  })
}

watch(() => searchQuery.value, () => {
  filterItems()
}, { immediate: true })

watch(() => filters, () => {
  filterItems()
}, { immediate: true, deep: true })

</script>

<template>
  <v-container>
    <div>
      <v-data-iterator :items="filteredItems" :page="page">
        <template #header>
          <v-toolbar class="px-2">
            <v-text-field
              v-model="searchQuery"
              class="mr-3"
              density="comfortable"
              placeholder="Search"
              prepend-inner-icon="mdi-magnify"
              style="max-width: 300px;"
              variant="solo"
              clearable
              hide-details
            ></v-text-field>
            <v-menu
                v-model="filtersOpen"
                :close-on-content-click="false"
                location="bottom"
                min-width="300"
              >
                <template v-slot:activator="{ props }">
                  <v-btn
                    color="secondary"
                    v-bind="props"
                  >
                    Suche filtern
                  </v-btn>
                </template>
                <real-estate-filter-form v-model="filters"></real-estate-filter-form>
            </v-menu>
          </v-toolbar>
        </template>
        <template v-slot:default="{ items }">
          <div class="d-inline-flex flex-wrap">
            <template
              v-for="(item, i) in items"
              :key="i"
            >
                <real-estate-list-entry class="my-4" :item="item.raw"
                  @click:details="clickRealEstateDetails($event)"
                 />
            </template>
          </div>
        </template>
        <template #footer>
          <v-pagination class="mt-4" v-model="page" :length="pagesCount"></v-pagination>
        </template>
      </v-data-iterator>
    </div>
  </v-container>
</template>
